
import java.awt.*;
import baukasten2.*;

public class Haus {

    protected Fenster kf;
    protected int zX, zY, zBreite, zHoehe, zR;
    protected boolean zSichtbar;
    protected boolean zLichtAn, zTuerAuf;
    protected Rechteck hWand;
    protected Dreieck hDach;
    protected GeoDreieck hT;
    protected Rechteck hTuer;            
    protected Rechteck hFenster1, hFenster2, hFenster3;
    protected Linie hL1, hL2;
    
    public Haus (Fenster zf, int xPos, int yPos, int breite) {
       kf = zf;  
       zX = xPos; zY = yPos; zBreite = breite;
       zHoehe=zBreite;
       zR = (int)(zBreite / 5);
       zLichtAn = false;
       zTuerAuf = false;
    }

    public void zeichnen() {
       WandZeichnen();
       DachZeichnen();
       TuerZeichnen();
       FensterZeichnen();
       zSichtbar = true;
    }
    
    public void WandZeichnen()
    {
        hWand = new Rechteck (kf, zX, zY, zBreite, zHoehe, Color.lightGray);
        hWand.zeichnen();
    }
    
    public void DachZeichnen()
    {
        hDach = new Dreieck (kf, (int)(zX), zY-zHoehe, (int)(zBreite), Color.red);
        hDach.zeichnen();
        hL1=new Linie (kf,zX-zR,zY-zHoehe+zR,(int)(zX+zBreite/2), (int)(zY-zHoehe-zBreite/2),Color.black,(int)(zBreite/20));
        hL1.zeichnen();
        hL2=new Linie (kf,(int)(zX+zBreite/2), (int)(zY-zHoehe-zBreite/2),zX+zBreite+zR,zY-zHoehe+zR,Color.black,(int)(zBreite/20));
        hL2.zeichnen();
    }
    
    public void TuerZeichnen()
    {
        hTuer = new Rechteck (kf, zX+zR, zY, zR, 2*zR, Color.red);
        hTuer.zeichnen();
        hT= new GeoDreieck (kf,zX+zR,zY,zR,Color.red,'r');
    }
    
    public void FensterZeichnen()
    {
        hFenster1 = new Rechteck (kf, zX+3*zR, zY-zR, zR, zR, Color.white);
        hFenster2 = new Rechteck (kf, zX+zR, zY-3*zR, zR, zR, Color.white);
        hFenster3 = new Rechteck (kf, zX+3*zR, zY-3*zR, zR, zR, Color.white);
        hFenster1.zeichnen();
        hFenster2.zeichnen();
        hFenster3.zeichnen();   
    }
    
    
    public void loeschen() {
       hWand.loeschen();
       hDach.loeschen();
       zSichtbar = false;
    }
    
    public void tuerAuf() {
       if (zLichtAn)
       hT.setzeFarbe(Color.yellow);
       else
       hT.setzeFarbe(Color.white);
       hT.zeichnen();
       zTuerAuf = true;
    }
    
    public void tuerZu() {
       hTuer.setzeFarbe (Color.red);
       hTuer.zeichnen();
       zTuerAuf = false;
    }
    
    public void lichtAn()  {
       hFenster1.setzeFarbe (Color.yellow);
       hFenster2.setzeFarbe (Color.yellow);
       hFenster3.setzeFarbe (Color.yellow);
       if (zTuerAuf)
       {hT.setzeFarbe(Color.yellow);
       hT.zeichnen();}
       zLichtAn = true;
    }
       
    public void lichtAus() {
       hFenster1.setzeFarbe (Color.white);
       hFenster2.setzeFarbe (Color.white);
       hFenster3.setzeFarbe (Color.white);
       if (zTuerAuf)
       {hT.setzeFarbe(Color.white);
       hT.zeichnen();}
       zLichtAn = false;
    }
       
    public boolean istTuerAuf() {
        return zTuerAuf;
    }
       
    public boolean istLichtAn() {
        return zLichtAn;
    }
} //End Class
