package baukasten2;

/**
 *  Baukasten: Klasse Bogen
 * 
 *  @author Peter Damann 
 *  @version 08.07.2012
 */

import java.awt.*;     // Color
import java.math.*;    // sin, cos

public class Bogen {

   Fenster kZf;
   Graphics kLw;
   int zX, zY, zB, zH;
   Color zFarbe;
   boolean zSichtbar;

   public Bogen (Fenster zf, int xPos, int yPos, int breite, Color farbe) {
       kZf = zf;
       kLw= kZf.getGraphics();                 // Leinwand = Zeichenflaeche
       zX = xPos + kZf.getInsets().left;
       zY = yPos + kZf.getInsets().top;
       zB = breite;
       zH = (int)(zB * 0.5);
       zFarbe = farbe;
       zSichtbar = false;
    }

   public void zeichnen() { 
       Color farbeAlt;
       Polygon eckpunkte;
       int i;
                        
       eckpunkte = new Polygon();
       eckpunkte.addPoint (zX, zY);
       eckpunkte.addPoint (zX, zY-zH);
       eckpunkte.addPoint (zX+zB, zY-zH);
       eckpunkte.addPoint (zX+zB, zY);

       for (i=0; i<11; i=i+1) {
          eckpunkte.addPoint (zX + (int)(0.5*zB + 0.30*zB * Math.cos(i*18*0.0175)), zY - (int)(0.30*zB * Math.sin(i*18*0.0175)));
        }
        
       farbeAlt = kLw.getColor();
       kLw.setColor (zFarbe);
       kLw.fillPolygon (eckpunkte);
       kLw.setColor (Color.black);
       kLw.drawPolygon (eckpunkte);
       kLw.setColor (farbeAlt);
       zSichtbar = true;
     }
 
   public void loeschen() {
       Color farbeAlt;
       Polygon eckpunkte;
       int i;                
       eckpunkte = new Polygon();
       eckpunkte.addPoint (zX, zY);
       eckpunkte.addPoint (zX, zY-zH);
       eckpunkte.addPoint (zX+zB, zY-zH);
       eckpunkte.addPoint (zX+zB, zY);
       for (i=0; i<11; i=i+1) {
         eckpunkte.addPoint (zX + (int)(0.5*zB + 0.30*zB * Math.cos(i*18*0.0175)), zY - (int)(0.30*zB * Math.sin(i*18*0.0175)));
        }
       farbeAlt = kLw.getColor();
       kLw.setColor (Color.white);
       kLw.fillPolygon (eckpunkte);
       kLw.setColor (Color.white);
       kLw.drawPolygon (eckpunkte);
       kLw.setColor (farbeAlt);
       zSichtbar = false;
    }
    
   public void setzeFarbe (Color farbe) {
       zFarbe = farbe;
       if (zSichtbar)
          zeichnen();
    }
    
   public void setzePosition (int xPos, int yPos) {
       if (zSichtbar) {
          loeschen();
          zX = xPos;
          zY = yPos;
          zeichnen();
       }
       else {
          zX = xPos;
          zY = yPos;  
       }    
    }
   
   public int liesXPosition() {
      return zX;
    }

   public int liesYPosition() {
      return zY;
    }
    
 } // class