package baukasten2;

/**
 * Klasse Dreieck
 * 
 * @author Peter Damann 
 * @version 29.06.2012
 */

import java.awt.*;  // Color

public class Dreieck {
    
  // Attribute
  
   private Fenster kZf;
   private Graphics kLw;
   private int zX, zY, zB, zH;
   private Color zFarbe;
   private boolean zSichtbar;

  // Konstruktoren
  
    /** Konstruktor */
    public Dreieck (Fenster Zf, int xPos, int yPos, int breite, Color farbe)
    {    
        // Instanzvariable initialisieren
        kZf = Zf;
        kLw= kZf.getGraphics();  // Leinwand = Zeichenflaeche
        zX = xPos + kZf.getInsets().left;
        zY = yPos + kZf.getInsets().top;
        zB = breite;
        zH = breite / 2;
        zFarbe = farbe;
     }

   // Methoden
   
    /** zeichnet die Figur */
    public void zeichnen() {
        // kLw= kZf.getGraphics();
        Polygon eckpunkte;
        
        eckpunkte = new Polygon();
        eckpunkte.addPoint (zX, zY);
        eckpunkte.addPoint (zX + zB, zY);
        eckpunkte.addPoint (zX + zB/2, zY - zH);
        
        kLw.setColor (zFarbe);
        kLw.fillPolygon (eckpunkte);
        kLw.setColor (Color.black);
        kLw.drawPolygon (eckpunkte);
        zSichtbar = true;
    }
 
    /** bermalt die Figur mit weier Farbe */
    public void loeschen() {
        // ...
        zSichtbar = false;
    }
    
    /** Farbe ... */
    public void setzeFarbe (Color farbe) {
        zFarbe = farbe;
        zeichnen();
    }
    
    /** Bezugspunkt: Ecke unten links */
    public void setzePosition (int xPos, int yPos) {
        zX = xPos;
        zY = yPos;
        if (zSichtbar)
            zeichnen();
    }
    
    /** liefert die x-Koordinate der Figur */
    public int liesXPosition() {
        return zX;
    }
    
    /** liefert die y-Koordinate der Figur */
    public int liesYPosition() {
        return zY;
    }
    
} // class