package baukasten2;

/**
 * Klasse GeoDreieck
 * 
 * @author Peter Damann 
 * @version 25.07.2012
 */

import java.awt.*;  // Color

public class GeoDreieck {
   private Fenster kZf;
   private Graphics kLw;
   private int zX, zY, zB, zH;
   private Color zFarbe;
   private char zW;
   private boolean zSichtbar;

   public GeoDreieck (Fenster Zf, int xPos, int yPos, int breite, Color farbe, char rechterWinkel)
   {      
      kZf = Zf;
      kLw= kZf.getGraphics();  // Leinwand = Zeichenflaeche
      zX = xPos + kZf.getInsets().left;
      zY = yPos + kZf.getInsets().top;
      zB = breite;
      if ((rechterWinkel == 'l') || (rechterWinkel == 'r'))
          zH = breite;
        else
          zH = breite/2;
      zFarbe = farbe;
      zW = rechterWinkel;
      zSichtbar = false;
   }

   public void zeichnen() {
       Polygon eckpunkte;
        
       eckpunkte = new Polygon();
       if (zW == 'l') {
          eckpunkte.addPoint (zX, zY);
          eckpunkte.addPoint (zX+zB, zY);
          eckpunkte.addPoint (zX, zY-zH);  
        }
        else if (zW == 'r') {
          eckpunkte.addPoint (zX, zY);
          eckpunkte.addPoint (zX+zB, zY);
          eckpunkte.addPoint (zX+zB, zY-zH); 
        }
        else {
          eckpunkte.addPoint (zX, zY);
          eckpunkte.addPoint (zX + zB, zY);
          eckpunkte.addPoint (zX + zB/2, zY - zH);
        }
       kLw.setColor (zFarbe);
       kLw.fillPolygon (eckpunkte);
       kLw.setColor (Color.black);
       kLw.drawPolygon (eckpunkte);
       zSichtbar = true;
    }
 
    public void loeschen() {
        Polygon eckpunkte;
        Color farbeAlt;       
        eckpunkte = new Polygon();
        if (zW == 'l') {
           eckpunkte.addPoint (zX, zY);
           eckpunkte.addPoint (zX+zB, zY);
           eckpunkte.addPoint (zX, zY-zH);  
        }
        else if (zW == 'r') {
           eckpunkte.addPoint (zX, zY);
           eckpunkte.addPoint (zX+zB, zY);
           eckpunkte.addPoint (zX+zB, zY-zH); 
        }
        else {
           eckpunkte.addPoint (zX, zY);
           eckpunkte.addPoint (zX + zB, zY);
           eckpunkte.addPoint (zX + zB/2, zY - zH);
        }
        farbeAlt = kLw.getColor();
        kLw.setColor (Color.white);
        kLw.fillPolygon (eckpunkte);
        kLw.drawPolygon (eckpunkte);
        kLw.setColor (farbeAlt);
        zSichtbar = false;
    }
    
    public void setzeFarbe (Color farbe) {
       zFarbe = farbe;
       if (zSichtbar)
           zeichnen();
    }
   
    public void setzePosition (int xPos, int yPos) {
       if (zSichtbar) {
          loeschen();
          zX = xPos; zY = yPos;
          zeichnen();
        }
        else {
          zX = xPos; zY = yPos;   
        }    
    }
    
    public int liesXPosition() {
        return zX;
    }
    
    public int liesYPosition() {
        return zY;
    }
    
} // class GeoDreieck
