package baukasten2;

/**
 *  Baukasten: Klasse Quadrat
 *  
 *  @Author Peter Damann
 *  @Version 08.07.2012
 */

import java.awt.*;  // Color

public class Quadrat
{
    // Attribute
	
   private Fenster kZf;
   private Graphics kLw;
   private int zX, zY, zB;
   private Color zFarbe;
   private boolean zSichtbar;


    // Konstrutor(en)

	/** Konstruktor: erzeugt ein Objekt der Klasse Quadrat */
	public Quadrat (Fenster zf, int xPos, int yPos, int breite, Color farbe)
    {    
        // Instanzvariable initialisieren
        kZf = zf;
        kLw = kZf.getGraphics();  // Leinwand = Zeichenflaeche
        zX = xPos + kZf.getInsets().left;
        zY = yPos + kZf.getInsets().top;
        zB = breite;
        zFarbe = farbe;
     }
     
     // Methoden	

    /** zeichnet die Figur */
    public void zeichnen() {
        Color farbeAlt;
        farbeAlt = kLw.getColor();
        kLw.setColor (zFarbe);
        kLw.fillRect (zX, zY-zB, zB, zB);
        kLw.setColor (Color.black);
        kLw.drawRect (zX, zY-zB, zB, zB);
        kLw.setColor (farbeAlt);
        zSichtbar = true;
    }
     
    /** bermalt die Figur mit weier Farbe */
    public void loeschen() {
        Color farbeAlt;
        farbeAlt = kLw.getColor();
        kLw.setColor (Color.white);
        kLw.fillRect (zX, zY-zB, zB, zB);
        kLw.drawRect (zX, zY-zB, zB, zB);
        kLw.setColor (farbeAlt);
        zSichtbar = false;
    }
    
    /** zeichnet die Figur in der neuen Farbe */
    public void setzeFarbe (Color farbe) {
        zFarbe = farbe;
        if (zSichtbar)
           zeichnen();
    }
     
    /** Bezugspunkt: Ecke unten links */
    public void setzePosition (int xPos, int yPos) {
        if (zSichtbar) {
           loeschen(); 
           zX = xPos; zY = yPos;
           zeichnen();
        }
        else {
           zX = xPos; zY = yPos;  
        }
    }
    
    /** liefert die x-Koordinate der Figur */
    public int liesXPosition() {
        return zX;
    }
    
    /** liefert die y-Koordinate der Figur */
    public int liesYPosition() {
        return zY;
    }
     
     
}  // Klasse Quadrat
